/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2007-2008, 2010-2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#define MF_SOURCE_APPINIT 1
#define MF_SOURCE_DEBUG 2
#define MF_SOURCE_CACHE 3
#define MF_SOURCE_CALLOUT 4
#define MF_SOURCE_DNSCACHE 5
#define MF_SOURCE_DB 6
#define MF_SOURCE_DEPRECATION 7
#define MF_SOURCE_DNS 8
#define MF_SOURCE_DNSBASE 9
#define MF_SOURCE_ENGINE 10
#define MF_SOURCE_GRAM 11
#define MF_SOURCE_LEX 12
#define MF_SOURCE_MAIN 13
#define MF_SOURCE_MF_STATUS 14
#define MF_SOURCE_MU_DBM 15
#define MF_SOURCE_MODLIST 16
#define MF_SOURCE_OPTAB 17
#define MF_SOURCE_PP 18
#define MF_SOURCE_PRAGMA 19
#define MF_SOURCE_PROG 20
#define MF_SOURCE_SAVCLT 21
#define MF_SOURCE_SAVSRV 22
#define MF_SOURCE_SRVMAN 23
#define MF_SOURCE_SPF 24
#define MF_SOURCE_STACK 25
#define MF_SOURCE_SYMBOLS 26
#define MF_SOURCE_RATE 27
#define MF_SOURCE_TBF_RATE 28


void init_debug_modlist(void);

void debug_init(char **names);
int debug_level_p(int modn, int level);
void debug_enable_module(const char *file, int level);
int debug_module_level(const char *modname, int *plev);
void debug_parse_spec(const char *spec);
void debug_log(char *fmt, ...);
int debug_spec_string(const char *spec, int minlevel, int showunset,
		      char **pbuf);
size_t debug_register(char *name);

#ifndef MF_SOURCE_NAME
# define MF_SOURCE_NAME 0
#endif

#define __DBG(lev) if (debug_level_p(MF_SOURCE_NAME, lev))

#define __debug(text)                                                         \
 do {                                                                         \
   if (source_info_option)                                                    \
     debug_log("%s:%lu:%s: %s", __FILE__, __LINE__, __FUNCTION__, text);      \
   else                                                                       \
     debug_log("%s", text);                                                   \
 } while (0)                                                                  

#define debug(lev,text)                                                       \
 do { __DBG(lev) __debug(text); } while(0)


#define __debug1(fmt, x1)  \
 do {                                                                         \
   if (source_info_option)                                                    \
    debug_log("%s:%lu:%s: " fmt, __FILE__, __LINE__, __FUNCTION__, x1); \
   else                                                                       \
    debug_log(fmt,x1);\
 } while (0)                                                                  
#define debug1(lev, fmt, x1) \
 do { __DBG(lev) __debug1(fmt, x1); } while(0)



#define __debug2(fmt, x1, x2)  \
 do {                                                                         \
   if (source_info_option)                                                    \
    debug_log("%s:%lu:%s: " fmt, __FILE__, __LINE__, __FUNCTION__, x1, x2); \
   else                                                                       \
    debug_log(fmt,x1, x2);\
 } while (0)                                                                  
#define debug2(lev, fmt, x1, x2) \
 do { __DBG(lev) __debug2(fmt, x1, x2); } while(0)



#define __debug3(fmt, x1, x2, x3)  \
 do {                                                                         \
   if (source_info_option)                                                    \
    debug_log("%s:%lu:%s: " fmt, __FILE__, __LINE__, __FUNCTION__, x1, x2, x3); \
   else                                                                       \
    debug_log(fmt,x1, x2, x3);\
 } while (0)                                                                  
#define debug3(lev, fmt, x1, x2, x3) \
 do { __DBG(lev) __debug3(fmt, x1, x2, x3); } while(0)



#define __debug4(fmt, x1, x2, x3, x4)  \
 do {                                                                         \
   if (source_info_option)                                                    \
    debug_log("%s:%lu:%s: " fmt, __FILE__, __LINE__, __FUNCTION__, x1, x2, x3, x4); \
   else                                                                       \
    debug_log(fmt,x1, x2, x3, x4);\
 } while (0)                                                                  
#define debug4(lev, fmt, x1, x2, x3, x4) \
 do { __DBG(lev) __debug4(fmt, x1, x2, x3, x4); } while(0)



#define __debug5(fmt, x1, x2, x3, x4, x5)  \
 do {                                                                         \
   if (source_info_option)                                                    \
    debug_log("%s:%lu:%s: " fmt, __FILE__, __LINE__, __FUNCTION__, x1, x2, x3, x4, x5); \
   else                                                                       \
    debug_log(fmt,x1, x2, x3, x4, x5);\
 } while (0)                                                                  
#define debug5(lev, fmt, x1, x2, x3, x4, x5) \
 do { __DBG(lev) __debug5(fmt, x1, x2, x3, x4, x5); } while(0)



#define __debug6(fmt, x1, x2, x3, x4, x5, x6)  \
 do {                                                                         \
   if (source_info_option)                                                    \
    debug_log("%s:%lu:%s: " fmt, __FILE__, __LINE__, __FUNCTION__, x1, x2, x3, x4, x5, x6); \
   else                                                                       \
    debug_log(fmt,x1, x2, x3, x4, x5, x6);\
 } while (0)                                                                  
#define debug6(lev, fmt, x1, x2, x3, x4, x5, x6) \
 do { __DBG(lev) __debug6(fmt, x1, x2, x3, x4, x5, x6); } while(0)

